package de.davidochmann.website.vitaoase.bottomline
{
	
	/**
	 * @author MR.WUT4
	 */

	import flash.display.MovieClip;	
	import flash.events.Event;	
	import flash.display.Graphics;	 
	import flash.display.Stage;	
	import flash.display.Sprite;	
	import de.davidochmann.framework.dosite.interfaces.IContent;

	public class BottomLine extends MovieClip implements IContent 
	{
		private static var FLAP_GAP:int    = -11;
		private static var FLAP_COLOR:uint = 0x0172FF; 
		
		private var mStage:Stage;
		private var mWidth:uint;
		private var mHeight:uint;
		
		private var mLeftFlap:Sprite;
		private var mRightFlap:Sprite;
		
		
		public function BottomLine()
		{}
		
		public function initialize():void
		{
			initFlaps();			
			drawFlaps();
			initStageEventHandler();
			addChildren();
		}
		
		public function getStage():Stage
		{
			return mStage;
		}
		
		public function getWidth():uint
		{
			return mWidth;
		}
		
		public function getHeight():uint
		{
			return mHeight;
		}
		
		public function getId():String
		{
			return null;
		}
		
		public function getPath():String
		{
			return null;
		}
		
		public function setStage(pStage:Stage):void
		{
			mStage = pStage;
		}

		public function setWidth(pWidth:uint):void
		{
			mWidth = pWidth;
		}

		public function setHeight(pHeight:uint):void
		{
			mHeight = pHeight;
		}

		public function setId(pIdentifier:String):void
		{
		}
		
		public function setPath(pPath:String):void
		{
		}
		
		
		private function initStageEventHandler():void
		{
			mStage.addEventListener(Event.RESIZE, StageResizeHandler);
		}

		private function StageResizeHandler(e:Event):void
		{
			drawFlaps();	
		}

		private function initFlaps():void
		{
			mRightFlap = new Sprite();
			mLeftFlap  = new Sprite();
		}
		
		private function drawFlaps():void
		{
			var flapWidth:uint = mStage.stageWidth * .5 + x;
			
			var canvasLeft:Graphics = mLeftFlap.graphics;
			var canvasRight:Graphics = mRightFlap.graphics;
			
			canvasLeft.beginFill(FLAP_COLOR);
			canvasLeft.drawRect(0, FLAP_GAP, -flapWidth, mHeight);
			canvasLeft.endFill();
			
			canvasRight.beginFill(FLAP_COLOR);
			canvasRight.drawRect(mWidth, FLAP_GAP, flapWidth, mHeight);
			canvasRight.endFill();
		}
		
		private function addChildren():void
		{
			addChild(mLeftFlap);
			addChild(mRightFlap);
		}
	}
}
