package de.davidochmann.website.vitaoase.navigation.bottom 
{
	/**
	 * @author dochmann
	 */
	 
	import flash.events.MouseEvent;	
	import flash.display.Sprite;

	public class MenuBottom extends Sprite 
	{
		private static var BUTTON_X:uint	 		   = 1;
		private static var BUTTON_Y:uint	 		   = 0;
		private static var BUTTON_DISTANCE:uint 	   = 163;
		private static var BUTTON_ANIMATION_TIME:uint  = 1;
				
		private static var LINE_COLOR_1:uint		   = 0x006AED;
		private static var LINE_COLOR_2:uint		   = 0x177EFE;
	
		private static var BUTTON_LIST:Array 		   = [{label:"Home"		      	   , link:"home"   , tx:65, ty:12},
												   		  {label:"Fitness und Therapie", link:"fitness", tx:15, ty:12},
												   		  {label:"Ernährung und Figur" , link:"figur"  , tx:15, ty:12},
												   		  {label:"Beauty und Wellness" , link:""	   , tx:15, ty:12},
												  		  {label:"Event und Seminare"  , link:""	   , tx:15, ty:12}];
		
		
		public function MenuBottom() 
		{
			initButtons();	
		}
		
		
		private function initButtons():void
		{
			var button:BottomButton;
			var line:BottomLine;
			
			var label:String;
			var link:String;
			var tx:uint;
			var ty:uint;
			
			for(var i:uint = 0; i < BUTTON_LIST.length; i++)
			{
				label = BUTTON_LIST[i].label;
				link  = BUTTON_LIST[i].link;
				tx 	  = BUTTON_LIST[i].tx;
				ty	  = BUTTON_LIST[i].ty;
				
				button = new BottomButton(label, tx, ty, link, BottomButton.STATUS_INACTIVE);
				
				button.x = BUTTON_X + (BUTTON_DISTANCE * i);
				button.y = BUTTON_Y;
				
				button.addEventListener(MouseEvent.MOUSE_OVER, buttonMouseOverHandler);
				button.addEventListener(MouseEvent.MOUSE_OUT , buttonMouseOutHandler);
				
				if(link != "" && link != null)
				{
					button.buttonMode 	 = true;
					button.mouseChildren = false;
					button.addEventListener(MouseEvent.MOUSE_UP, buttonMouseUpHandler);
				}
				
				addChild(button);	
			}
			
			for(var j:uint = 1; j < BUTTON_LIST.length; j++)
			{
				line = new BottomLine(LINE_COLOR_1, LINE_COLOR_2);
				
				line.x = BUTTON_X + (BUTTON_DISTANCE * j);
				line.y = BUTTON_Y; 
				
				addChild(line);			
			}
		}
		
		private function buttonMouseUpHandler(e:MouseEvent):void
		{
			var link:String = BottomButton(e.currentTarget).getLink();
			openLink(link);
		}

		private function buttonMouseOverHandler(e:MouseEvent):void
		{
			BottomButton(e.currentTarget).status(BottomButton.STATUS_ACTIVE, BUTTON_ANIMATION_TIME);
		}

		private function buttonMouseOutHandler(e:MouseEvent):void
		{
			BottomButton(e.currentTarget).status(BottomButton.STATUS_INACTIVE, BUTTON_ANIMATION_TIME);
		}
		
		private function openLink(pLink:String):void
		{	
			SWFAddress.setValue(pLink);
		}
	}
}
