package de.davidochmann.website.vitaoase.navigation.top
{
	/**
	 * @author dochmann
	 */
	import flash.events.Event;	 
	import flash.display.Graphics;	 
	import flash.display.Sprite;	
	import flash.display.Stage;	
	import flash.display.MovieClip;
	import de.davidochmann.framework.dosite.interfaces.IContent;

	public class NavigationTop extends MovieClip implements IContent 
	{
		private static var FLAP_GAP:int    		= 0;
		private static var FLAP_COLOR:uint 		= 0x0172FF; 
		
		private static var LINE_COLOR_1:uint	= 0x006AED;
		private static var LINE_COLOR_2:uint	= 0x177EFE;
		
		private var mStage:Stage;
		private var mWidth:uint;
		private var mHeight:uint;
		private var mId:String;
		private var mPath:String;
		
		private var mBackground:Sprite;
		private var mMenu:MenuTop;

		private var mLeftFlap:Sprite;
		private var mRightFlap:Sprite;

		public function NavigationTop()
		{
		}
		
		
		public function initialize():void
		{
			initFlaps();			
			drawFlaps();
			
			initBackground();
			initEventHandler();
			initMenu();
			
			addChildren();
		}
		
		
		public function getStage():Stage
		{
			return mStage;
		}

		public function getWidth():uint
		{
			return mWidth;
		}

		public function getHeight():uint
		{
			return mHeight;
		}

		public function getId():String
		{
			return mId;
		}

		public function getPath():String
		{
			return mPath;
		}

		
		public function setStage(pStage:Stage):void
		{
			mStage = pStage;
		}

		public function setWidth(pWidth:uint):void
		{
			mWidth = pWidth;
		}

		public function setHeight(pHeight:uint):void
		{
			mHeight = pHeight;
		}

		public function setId(pId:String):void
		{
			mId = pId;
		}

		public function setPath(pPath:String):void
		{}
		
		
		private function initBackground():void
		{
			mBackground = new Sprite();
			
			var canvas:Graphics = mBackground.graphics;
			
			canvas.beginFill(LINE_COLOR_1);
			canvas.drawRect(0, 0, mWidth, 1);
			canvas.drawRect(0, mHeight - 1, mWidth, 1);
			canvas.drawRect(0, 1, 1, mHeight - 2);
			canvas.drawRect(mWidth - 1, 1, 1, mHeight - 2);
			canvas.endFill();
			
			canvas.beginFill(LINE_COLOR_2);
			canvas.drawRect(0, 1, mWidth, 1);
			canvas.drawRect(0, mHeight - 2, mWidth, 1);
			canvas.endFill();
		}

		private function initFlaps():void
		{
			mRightFlap = new Sprite();
			mLeftFlap  = new Sprite();
		}
		
		private function initEventHandler():void
		{
			mStage.addEventListener(Event.RESIZE, StageResizeHandler);
		}

		private function StageResizeHandler(e:Event):void
		{
			drawFlaps();	
		}
		
		private function drawFlaps():void
		{
			var flapWidth:uint = mStage.stageWidth * .5 + x;
			
			var canvasLeft:Graphics = mLeftFlap.graphics;
			var canvasRight:Graphics = mRightFlap.graphics;
			
			canvasLeft.beginFill(FLAP_COLOR);
			canvasLeft.drawRect(0, FLAP_GAP, -flapWidth, mHeight);
			canvasLeft.endFill();
			
			canvasRight.beginFill(FLAP_COLOR);
			canvasRight.drawRect(mWidth, FLAP_GAP, flapWidth, mHeight);
			canvasRight.endFill();
		}

		private function initMenu():void
		{
			mMenu = new MenuTop();
		}
		
		private function addChildren():void
		{
			addChild(mLeftFlap);
			addChild(mRightFlap);
			addChild(mMenu);
			addChild(mBackground);
		}
	}
}
