package de.davidochmann.website.vitaoase.navigation.top
{
	/**
	 * @author dochmann
	 */

	import gs.easing.Strong;	
	import gs.TweenMax;		
	import flash.text.TextFieldAutoSize;	
	import flash.text.TextFormatAlign;	
	import flash.text.TextFormat;	
	import flash.text.TextField;	
	import flash.display.Graphics;	
	import flash.display.Sprite;
	import flash.filters.DropShadowFilter;	 

	public class TopButton extends Sprite 
	{
		public static var STATUS_ACTIVE:String   = "STATUS_ACTIVE";
		public static var STATUS_INACTIVE:String = "STATUS_INACTIVE";
		
		private static var HIGHLIGHT_COLOR:uint   = 0x0061D8;
		private static var HIGHLIGHT_WIDTH:uint   = 100;
		private static var HIGHLIGHT_HEIGHT:uint  = 25;
		
		private static var TEXT_COLOR:uint 		  = 0xFFFFFF;
		
		private var mLabel:TextField;
		private var mLink:String;
		private var mStatus:String;
		
		private var mHighlight:Sprite;
		
		public function TopButton(pLabel:String,
								   pLabelX:uint,
								   pLabelY:uint,
								   pLink:String, 
								   pStatus:String)
		{		
			initHighlight();
			initLabel();

			setLabel(pLabel);
			setLabelX(pLabelX);
			setLabelY(pLabelY);
			setLink(pLink);
			
			status(pStatus, 0);
			
			addChildren();
		}
		
		
		public function status(pStatus:String, pTime:uint):void
		{
			switch(pStatus)
			{
				case STATUS_ACTIVE:
					setStatus(STATUS_ACTIVE);
					highlight(pTime);
					break;
					
				case STATUS_INACTIVE:
					setStatus(STATUS_INACTIVE);
					lowlight(pTime);
					break;
			}
		}


		
		public function setLabel(pLabel:String):void
		{
			mLabel.text = pLabel;
		}

		public function setLabelX(pLabelX:int):void
		{
			mLabel.x = pLabelX;
		}

		public function setLabelY(pLabelY:int):void
		{
			mLabel.y = pLabelY;
		}

		public function setLink(pLink:String):void
		{
			mLink = pLink;
		}
		
		public function setStatus(pStatus:String):void
		{
			mStatus = pStatus;
		}

		
		public function getLabel():String
		{
			return mLabel.text;
		}		

		public function getLabelX():int
		{
			return mLabel.x;
		}

		public function getLabelY():int
		{
			return mLabel.y;
		}

		public function getLink():String
		{
			return mLink;
		}

		public function getStatus():String
		{
			return mStatus;
		}

		
		private function initHighlight():void
		{
			mHighlight = new Sprite();
			
			var shadow:DropShadowFilter = new DropShadowFilter(5, 90, 0x000000, .3, 0, 25, 1, 1, true, false, false);	
			var canvas:Graphics = mHighlight.graphics;
			
			canvas.beginFill(HIGHLIGHT_COLOR);
			canvas.drawRect(0, 0, HIGHLIGHT_WIDTH, HIGHLIGHT_HEIGHT);
			canvas.endFill();
			
			mHighlight.filters = [shadow];			
		}
		
		private function initLabel():void
		{
			mLabel = new TextField();
			
			var format:TextFormat = new TextFormat;
			
			format.font 			 = "Verdana";
			format.color 			 = TEXT_COLOR;
			format.align 			 = TextFormatAlign.LEFT;
			
			mLabel.defaultTextFormat = format;
			mLabel.mouseEnabled 	 = false;
			mLabel.autoSize 		 = TextFieldAutoSize.LEFT;
		}


		private function highlight(pTime:uint):void
		{
			TweenMax.to(mHighlight, pTime, {alpha:1, ease:Strong.easeOut});
		}

		private function lowlight(pTime:uint):void
		{
			TweenMax.to(mHighlight, pTime, {alpha:0, ease:Strong.easeOut});
		}

		
		private function addChildren():void
		{
			addChild(mHighlight);
			addChild(mLabel);
		}
	}
}
